add_printer("/craft.php", function ()
	text = text:gsub("%[.-discoveries.-%]", [[%0&nbsp;<a href="custom-mix-drinks" style="color:green;">{mix drinks}</a>]], 1)
end)

add_interceptor("/custom-mix-drinks", function ()
	local recp = str_to_table(get_recipes())
	local cocktailcrafting_recipes = {}
	local still_recipes = {}
	for a, b in pairs(recp) do
		if b.type == "cocktailcrafting" then
			cocktailcrafting_recipes[a] = str_to_table(b.ingredients)
		end
		if b.type == "still" then
			still_recipes[a] = b.ingredient
		end
	end
	local cached_ids = {}
	local inventory = str_to_table(get_inventory_counts())
	local equipment = str_to_table(str_to_table(get_status_info()).equipment)
	function get_amount_available(name)
		return (inventory[get_itemid(name)] or 0)
	end
	local garnishes = {
		["coconut shell"] = true,
		["little paper umbrella"] = true,
		["magical ice cubes"] = true,
	}
	local hippy_store = {
		herbs = 64,
		grapefruit = 70,
		grapes = 70,
		lemon = 70,
		olive = 70,
		orange = 70,
		strawberry = 70,
		tomato = 70,
	}
	local market_store = {
		["soda water"] = 70,
	}
	local store_price = {}
	for a,b in pairs(market_store) do store_price[a] = b end
	local dreadsack = (equipment.hat == get_itemid("filthy knitted dread sack")) or inventory[get_itemid("filthy knitted dread sack")]
	local corduroys = (equipment.pants == get_itemid("filthy corduroys")) or inventory[get_itemid("filthy corduroys")]
	if dreadsack and corduroys then
		for a,b in pairs(hippy_store) do store_price[a] = b end
	end
	local SHC = { "Neuromancer", "vodka stratocaster", "Mon Tiki", "teqiwila slammer", "Divine", "Gordon Bennett", "gimlet", "yellow brick road", "mandarina colada", "tangarita", "Mae West", "prussian cathouse" }
	local resptext = ""
	for x, name in pairs(SHC) do
		resptext = resptext .. name .. ": " .. table.concat(cocktailcrafting_recipes[name], " + ") .. "<br>"
	end
	local resptext = ""
	local advcock = { "pink pony", "fuzzbump", "slip 'n' slide", "ocean motion", "ducha de oro", "horizontal tango", "roll in the hay", "a little sump'm sump'm", "slap and tickle", "perpendicular hula", "rockin' wagon", "calle de miel", "tropical swill", "fruity girl swill", "blended frozen swill", "bungle in the jungle" }
	function can_make(name)
		local available = get_amount_available(name)
		local craftable = 0
		local craft_steps = {}
		if cocktailcrafting_recipes[name] then
			craftable = 100
			for _, x in pairs(cocktailcrafting_recipes[name]) do
				local num, partsteps = can_make(x)
				for _, y in pairs(partsteps) do table.insert(craft_steps, y) end
				craftable = math.min(craftable, num)
			end
		end
		local buyable = 0
		if store_price[name] then
			buyable = 100
		end
		local steps = {}
		if available > 0 then
			table.insert(steps, "have " .. name .. " (" .. available .. ")")
		elseif buyable > 0 then
			table.insert(steps, "buy " .. name .. " (" .. store_price[name] .. " meat)")
		elseif craftable > 0 then
			for _, y in pairs(craft_steps) do table.insert(steps, y) end
			table.insert(steps, "mix " .. name)
		end
		return available + craftable + buyable, steps
	end
	function handle_recipe(name)
		local txt = ""
		for _, x in pairs(cocktailcrafting_recipes[name]) do
			txt = txt .. x .. " (" .. get_amount_available(x) ..  ")  "
		end
		local amount, steps = can_make(name)
		if amount > 0 then
			local stepstext = ""
			for _, x in pairs(steps) do
				stepstext = stepstext .. "<br><small>&nbsp;&nbsp;" .. x .. "</small>"
			end
			return name .. " {" .. amount .. "}: " .. txt .. stepstext
		else
			return [[<span style="color: gray;">]] .. name .. " {" .. amount .. "}: " .. txt .. [[</span>]]
		end
	end
	for x, name in pairs(advcock) do
		resptext = resptext .. handle_recipe(name) .. "<br>"
	end
	return resptext, path
end)
