add_interceptor("/automate-spading-mine-layouts", function ()
	setup_functions()
	local mallaccess = do_we_have_mall_access()
	local pwd = get_session_state("pwd") -- inserting pwd, boo!
	function equip_item(name, slot)
		return equip_itemid(get_itemid(name), slot)
	end
	equip_item("miner's helmet")
	equip_item("7-Foot Dwarven mattock")
	equip_item("miner's pants")
	equip_item("hippy medical kit", 1)
	local status = str_to_table(get_status_info())
	local equipment = str_to_table(status.equipment)
	if not mallaccess then
		text, url = "Not in aftercore.", path
	elseif equipment.hat ~= get_itemid("miner's helmet") or equipment.weapon ~= get_itemid("7-Foot Dwarven mattock") or equipment.pants ~= get_itemid("miner's pants") then
		text, url = "Couldn't equip mining outfit.", path
	elseif equipment.acc1 ~= get_itemid("hippy medical kit") and equipment.acc2 ~= get_itemid("hippy medical kit") and equipment.acc3 ~= get_itemid("hippy medical kit") then
		text, url = "Couldn't equip hippy medical kit (need HP-regen).", path
	elseif tonumber(status.adventures) < 36 then
		text, url = "Not enough turns (need 36+).", path
	else
		local layout_results = {}
		local times = math.floor(tonumber(status.adventures) / 36)
		while times > 0 do
			times = times - 1
--~ 				times = 0
			local pt, pturl = get_page("/mining.php", { intro = "1", mine = "1" })
			if pt:match("Find New Cavern") then
				post_page("/mining.php", { mine = "1", reset = "1", pwd = pwd })
			end
			set_ascension_state("mining.results.1", "")
			local mine_order = {
				49, 50, 51, 52, 53, 54,
				41, 42, 43, 44, 45, 46,
				33, 34, 35, 36, 37, 38,
				25, 26, 27, 28, 29, 30,
				17, 18, 19, 20, 21, 22,
				 9, 10, 11, 12, 13, 14,
			}
			for _, x in pairs(mine_order) do
				local pt, pturl = get_page("/mining.php", { mine = "1", which = tostring(x), pwd = pwd })
				if not pt:match("You start digging. You hit the rock with all your might.") then
					print("Error while spading mining: Mining request failed:\n" .. pt)
					error("Error while spading mining: Mining request failed.")
				end
			end
			local pt, pturl = get_page("/mining.php", { intro = "1", mine = "1" })
			if pt:match("<a href='mining.php?mine=1&which=") then
				print("Error while spading mining: Itznotyerzitz Mine wasn't cleared.")
				error("Error while spading mining: Itznotyerzitz Mine wasn't cleared.")
			else
				local line = "mining.results.1 (kolproxy, " .. charpane.charName:match([[^"(.+)"$]]) .. ", " .. os.date() .. "): "..tostring(get_ascension_state("mining.results.1")).."\n"
				table.insert(layout_results, line)
				f = io.open("spading-log.txt", "a+")
				f:write(line)
				f:close()
				print(line)
			end
		end
		text, url = table.concat(layout_results, "<br>"), path
	end
end)

add_printer("/main.php", function ()
	local mallaccess = do_we_have_mall_access()
	if mallaccess then
		local links = {
			{ title = "Mine layout spading", url = "automate-spading-mine-layouts" },
		}
		local rows = {}
		for _, x in pairs(links) do
			table.insert(rows, [[<tr><td><a href="]]..x.url..[[">]]..x.title..[[</a></td></tr>]])
		end
		text = text:gsub([[title="Bottom Edge"></td></tr>.</table>]], [[%0<table>]] .. table.concat(rows) .. [[</table>]])
	end
end)
